#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Widget.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Text_Display.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Button.H>
#include <FL/FL_Slider.h>
#include <FL/FL_Radio_Round_Button.h>
#include <FL/FL_draw.h>
#include <FL/FL_File_Chooser.h>
#include <FL/FL_File_Browser.h>
#include <string.h>
#include <FL/Fl_Hor_Nice_Slider.h>
#include <winbase.h>

#include <stddef.h>
#include <process.h>

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include "wget1102.h"
#include "goget07042006.h"
#include "gogetexe07032006.h"

using namespace std;

    Fl_Window *window;    
    char *shellName;
    
    char *ManSelectedDir;
    char recOutMPQName[_MAX_PATH];
    char mirrorLoc[_MAX_PATH*4];
    Fl_Box *ManSelectedDirOut;

    Fl_Group *groupA;
    Fl_Group *groupB;
    Fl_Group *groupC;
        Fl_Group *groupCSubA;
    Fl_Group *groupD;
    Fl_Box *groupATitle;
    Fl_Slider *NudityLevelSlider;    
    char wowLocation[_MAX_PATH];
    char strWoWLocationFromReg[_MAX_PATH];
    char possibleMPQOutputNames[37][_MAX_PATH];
    
    char NLBatFile[][32]={"GoGet.Bat","MPQMake.Bat","EvenLess.Bat","TabTopOK.Bat","MakeTopl.Bat","FullNude.Bat","CustmRun.Bat",""};
    char HelperBatVar[][32]={"",
                                "NNNNNNYYYYN",//MPQMake
                                "NYYNNNYYYYY",//EvenLess
                                "NYYYNYYNYYYYY",//TabTopOK
                                "NYYYNYYYYYNNYYYYY",//MakeTopl
                                "NYYYYNYYYYYYYYYYYY",//FullNude
                                ""//CustmRun.Bat
                                };
    char wowDataLocation[_MAX_PATH];

      //GroupA
      Fl_Radio_Round_Button *RB_WindowsRegistryEntry;
         Fl_Box *RegOut;
      Fl_Radio_Round_Button *RB_ManualEntry;
         Fl_Button *butGetManSelectedDir;
      Fl_Radio_Round_Button *RB_FindEntry;
      Fl_Box *groupBTestText;
      
      //Group C
      Fl_Radio_Round_Button *RB_InternalFiles;
      Fl_Radio_Round_Button *RB_MirrorFiles;
               Fl_Radio_Round_Button *RB_MirrorFilesLocationWcSkinsCom;
               Fl_Radio_Round_Button *RB_MirrorFilesLocationGigabitAdult;               
               Fl_Radio_Round_Button *RB_MirrorFilesLocationToogCom;
               Fl_Radio_Round_Button *RB_MirrorFilesLocationBespin;
               Fl_Radio_Round_Button *RB_MirrorFilesLocationLocalNet;
      Fl_Radio_Round_Button *RB_CustomLocationFiles;
               Fl_Input *InputOfCustomLocation;
               Fl_Button *butPickLclFileURL;

      Fl_Box *RecMPQNameLabel;

    Fl_Button *butShowDir, *butReReadReg, *butShowScrnShDir, *butGo, *butSuggestMPQName, *butRunWoW, *butRunWoWLauncher, *butVisitMirror, *butDelMPQFiles, *butWriteSrc, *butDelPatBatFiles, *butWriteRegistryEntry, *butCloseProg;

//function prototypes
void groupA_RB_cb( Fl_Radio_Round_Button *);
void wowDirSet();
LPSTR GetRegString(HKEY, LPSTR, LPSTR, unsigned char *,unsigned long);
bool SetRegString(HKEY, LPSTR, LPSTR, unsigned char *,unsigned long);
void getWoWRegValue();

//Functions
bool isFileExist(char *tested)
{
     //http://c-faq.com/osdep/fileexists.html
     
     
     FILE *fp = fopen(tested,"r");
     if( fp ) {
         fclose(fp);
         return true;
     } else
        return fp;
}

//--------------------------------------------
void butShowDir_cb( Fl_Widget* o, void*  )
{
     /*
     char spotToSee[_MAX_PATH];
     strcpy(spotToSee,wowDataLocation);
     strcat(spotToSee,"patc*.MPQ");     
     spawnlp(P_NOWAIT,shellName,shellName,"/c","dir",spotToSee,NULL);
     */

     char ScrnDir[_MAX_PATH];
     strcpy(ScrnDir,wowLocation);
     strcat(ScrnDir,"Screenshots");
     
     char *ignored=fl_file_chooser("See what Patc*.MPQ files already exist.","Patc*.MPQ files (Patc*.MPQ)",wowDataLocation);
       window->redraw();
}          

void butReReadReg_cb( Fl_Widget* o, void*  )
{     
     /*
   Fl_Button* b=(Fl_Button*)o;
   b->label("Good job"); //redraw not necessary
 
   b->resize(10,150,140,30); //redraw needed
   b->redraw();
   */
//       system("dir");
/*
         spawnlp(P_NOWAIT,shellName,shellName,"/c","dir >> GoGetExeOutput.Txt",NULL);
         system("echo system >> GoGetExeOutput.Txt");
         system("ver >> GoGetExeOutput.Txt");
         spawnlp(P_WAIT,shellName,shellName,"/c","echo PWAIT >> GoGetExeOutput.Txt",NULL);
         spawnlp(P_WAIT,shellName,shellName,"/c","ver >> GoGetExeOutput.Txt",NULL);
         spawnlp(P_NOWAIT,shellName,shellName,"/c","echo PNOWAIT >> GoGetExeOutput.Txt",NULL);
         spawnlp(P_NOWAIT,shellName,shellName,"/c","ver >> GoGetExeOutput.Txt",NULL);
         spawnlp(P_NOWAIT,shellName,shellName,"/c","echo",shellName," >> GoGetExeOutput.Txt",NULL);
*/
         //This function now re-reads from registry
         getWoWRegValue();
         window->redraw();
}

void butShowScrnShDir_cb( Fl_Widget* o, void*  )
{
     char ScrnDir[_MAX_PATH];
     strcpy(ScrnDir,wowLocation);
     strcat(ScrnDir,"Screenshots");
     
     char *ignored=fl_file_chooser("Set WoW to save in ...","WoW Screenshots (*.{tga,png,jpeg})",ScrnDir);
     window->redraw();
}

void set_mirrorLoc()
{
          if( RB_MirrorFilesLocationWcSkinsCom->value() )
              strcpy(mirrorLoc,"http://www.warcraftskins.com/files/patnbat/");
          else if( RB_MirrorFilesLocationGigabitAdult->value() )
               //strcpy(mirrorLoc,"http://www.gigabitadult.com/sites/T/TOOGAM/nudewow/patnbat/");
               strcpy(mirrorLoc,"http://www.gigabitadult.com/sites/T/TOOGAM/");
          else if( RB_MirrorFilesLocationToogCom->value() )
               strcpy(mirrorLoc,"http://TOOGAM.com/games/wow/nudewow/patnbat/");
          else if( RB_MirrorFilesLocationBespin->value() )
               strcpy(mirrorLoc,"http://TOOGAM.Bespin.org/games/wow/nudewow/patnbat/");
          else if( RB_MirrorFilesLocationLocalNet->value() )
               strcpy(mirrorLoc,"http://192.168.1.1/patnbat/");
          else strcpy(mirrorLoc,"");
}

void butGo_cb( Fl_Widget* o, void*  ) {
     //if DLTools doesn't exist, make it.  Running the operating system's
     //   mkdir didn't actually seem any worse than alternatives of using
     //   stat() or findfirst() and _mkdir()
          char wgetExePathNoFileName[_MAX_PATH];
          strcpy(wgetExePathNoFileName,wowDataLocation);
          strcat(wgetExePathNoFileName,"DLTools");
          //spawnlp(P_WAIT,shellName,shellName,"/c","echo Please close this and the next window.  (If DLTools exists, this will cause an error message on the next window which can be safely ingored.)",wgetExePathNoFileName,NULL);
          //spawnlp(P_WAIT,shellName,shellName,"/c","mkdir",wgetExePathNoFileName,NULL);
          mkdir(wgetExePathNoFileName);

     char outputFilePath[_MAX_PATH];

     strcpy(outputFilePath,wowDataLocation);
     strcat(outputFilePath,"DLTools\\WGet.Exe");
     bool writeWGet=true;
     bool writeGoGet=true;
     bool overwriteOkay=true;
     bool overwriteWGetOkay=false;
     bool overwriteGoGetOkay=false;     
     bool writeHelper=true;
     bool overwriteHelperOkay=false;
     
     strcpy(wowDataLocation,wowLocation);
     strcat(wowDataLocation,"DATA\\");

     //fl_message("About to output wget");

     FILE *fp;
     fp = fopen(outputFilePath,"rb");
     if(fp)
     {
          fclose(fp);
           //spawnlp(P_NOWAIT,shellName,shellName,"/c","Echo WGet already exists",NULL);
           //fl_message("WGet already exists");
           if(overwriteOkay)
                 overwriteWGetOkay=(bool)fl_choice("WGet already exists.  Continue to overwrite?","No","Yes", NULL);
           
           //prompt here to change value of overwriteOkay?
           if(!overwriteOkay || !overwriteWGetOkay)
              writeWGet=false;
     }

     //fl_message("Wget existance checked");

     if(writeWGet)
     {
          fp = fopen(outputFilePath,"wb");
          if(!fp)
          {                          
                //spawnlp(P_NOWAIT,shellName,shellName,"/c","Echo Cannot open WGet.Exe for writing",NULL);
                fl_message("Cannot open WGet.Exe for writing");
                return;            
           }
           //wget1102data is in wget1102.h
           unsigned long fwrRet=fwrite(wget1102data,sizeof(char),wget1102datalen,fp);           
           
               if(fwrRet!=wget1102datalen)
               {
                    char errMsg[4096];
                    sprintf(errMsg,"Seems there was error writing WGet\nfwrite returned %ld",fwrRet);                    
                    fl_message(errMsg);
               }
           
           fclose(fp);           
     }

     //fl_message("Wrote wget");

     char downloadedFileURL[_MAX_PATH*4];
     bool usehttp=false;
     
     //write GoGet
     if(RB_InternalFiles->value())
     {
          //fl_message("Internal");
          strcpy(outputFilePath,wowDataLocation);
          strcat(outputFilePath,"GoGet.Bat");
     
          FILE *fp;
          fp = fopen(outputFilePath,"rb");
          if(fp)
          {
                fclose(fp);
                //spawnlp(P_NOWAIT,shellName,shellName,"/c","Echo GoGet.Bat already exists",NULL);
                //fl_message("GoGet.Bat already exists");
                if(overwriteOkay)
                      overwriteGoGetOkay=(bool)fl_choice("GoGet.Bat already exists.  Continue to overwrite?","No","Yes", NULL);
                                
                //prompt here to change value of overwriteOkay?
                if(!overwriteOkay || !overwriteGoGetOkay)
                    writeGoGet=false;
           }
           if(writeGoGet)
           {
               fp = fopen(outputFilePath,"wb");
               if(!fp)
               {          
                     //spawnlp(P_NOWAIT,shellName,shellName,"/c","Echo Cannot open GoGet.Bat for writing",NULL);
                     fl_message("Cannot open GoGet.Bat for writing");
                     return;            
               }
               //goget07022006data is in goget07022006.h
               unsigned long fwrRet=fwrite(gogetSrcData,sizeof(char),gogetSrcDatalen,fp);
               if(fwrRet!=gogetSrcDatalen)
               {
                    char errMsg[4096];
                    sprintf(errMsg,"Seems there was error writing GoGet\nfwrite returned %ld",fwrRet);                    
                    fl_message(errMsg);
               }

               fclose(fp);           
           }
     }//end if(RB_InternalFiles->value())
     else if(RB_MirrorFiles->value())
     {
          //set mirrorLoc
          set_mirrorLoc();
          strcpy(downloadedFileURL,mirrorLoc);
          usehttp=true;
               
     }
     else if(RB_CustomLocationFiles->value())
     {
          char copyOfInput[_MAX_PATH*4];          
          strcpy(copyOfInput,InputOfCustomLocation->value());
          usehttp=(bool)strstr(InputOfCustomLocation->value(),"http://");
          if(usehttp)
          {
               strcpy(downloadedFileURL,InputOfCustomLocation->value());
          }
          else if(strstr(InputOfCustomLocation->value(),"file://"))
          {
               char *afterProtocol;
               strcpy(copyOfInput,InputOfCustomLocation->value());
               afterProtocol=&(copyOfInput[7]);//after "file://"
               spawnlp(P_WAIT,shellName,shellName,"/c","copy",afterProtocol,wowDataLocation,NULL);
          }
     }
      
     if(usehttp)
     {
          //work more on getting GoGet
          char lwrCaseFName[32];
          char currDir[_MAX_PATH+2];
          
          
          strcpy(lwrCaseFName,NLBatFile[0*(int)NudityLevelSlider->value()]);
          strlwr(lwrCaseFName);
          strcat(downloadedFileURL,lwrCaseFName);

          getcwd(currDir,_MAX_PATH);
          chdir(wowDataLocation);
          spawnlp(P_WAIT,outputFilePath,outputFilePath,downloadedFileURL,NULL);
          chdir(currDir);
          usehttp=false;           
     }
     //else, look elsewhere?


     char *fileToUse=NLBatFile[(int)NudityLevelSlider->value()];
     if(!strcmp(fileToUse,"CustmRun.Bat") && !strlen(HelperBatVar[(int)NudityLevelSlider->value()]))
     {
           //spawnlp(P_NOWAIT,shellName,shellName,"/c","Echo Custom currently has no data, not supported",NULL);
           fl_message("Echo Custom currently has no data, not supported");
           return;                             
     }
     char pathToUse[_MAX_PATH];
     strcpy(pathToUse,wowDataLocation);
     strcat(pathToUse,fileToUse);
     //write helperBat
     if(NudityLevelSlider->value())
     {                                                                
          if(RB_InternalFiles->value())
          {
              strcpy(outputFilePath,wowDataLocation);
              strcat(outputFilePath,NLBatFile[1*(int)NudityLevelSlider->value()]);

              bool writeWGet=true;
              bool overwriteOkay=true;
              bool overwriteWGetOkay=false;
     
              FILE *fp;
              fp = fopen(outputFilePath,"rb");
              if(fp)
              {
                  fclose(fp);
                  //spawnlp(P_NOWAIT,shellName,shellName,"/c","Echo Helper already exists",outputFilePath,NULL);
                  if(overwriteOkay)
                        overwriteHelperOkay=(bool)fl_choice("Helper already exists.  Continue to overwrite?","No","Yes", NULL);

                  //fl_message("Helper already exists");
                  //if(!fl_choice("Helper already exists.  Continue to overwrite?","No","Yes"))
                    //    overwriteHelperOkay=false.
                  //prompt here to change value of overwriteOkay?
                  if(!overwriteOkay || !overwriteHelperOkay)
                      writeHelper=false;
              }
              if(writeHelper)
              {
                   fp = fopen(outputFilePath,"wb");
                   if(!fp)
                   {          
                        //spawnlp(P_NOWAIT,shellName,shellName,"/c","Echo Cannot open Helper for writing",NULL);
                        fl_message("Echo Cannot open Helper for writing");
                        return;            
                   }
                   fprintf(fp,"");

                   fprintf(fp,"@Echo Off\r\n");
                   fprintf(fp,"Echo This is meant for using with the June 26, 2006 release of GoInst.BTM\r\n");
                   fprintf(fp,"\r\n");                   
                   fprintf(fp,"If NOT Exist GoGet.Bat goto nogoget\r\n");
                   fprintf(fp,"goto gogetfnd\r\n");
                   fprintf(fp,"\r\n");                   
                   fprintf(fp,":nogoget\r\n");
                   fprintf(fp,"If NOT Exist GoGetLog.Bat goto notexi\r\n");
                   fprintf(fp,"goto gogetfnd\r\n");
                   fprintf(fp,"\r\n");
                   fprintf(fp,":gogetfnd\r\n");
                   fprintf(fp,"\r\n");

                   fprintf(fp,"Set AlNudInQ=");
                   fprintf(fp,"%s",HelperBatVar[(int)NudityLevelSlider->value()]);
                   fprintf(fp,"\r\n");

                   fprintf(fp,"Set AlNudQPs=No\r\n");
                   fprintf(fp,"Set AlNudWGOk=Yes\r\n");
                   fprintf(fp,"::Set AlNudKpL=\r\n");
                   fprintf(fp,"%s","Echo AlNudQPs is set to \%AlNudQPs and AlNudInQ is set to \%AlNudInQ\r\n");
                   fprintf(fp,"\r\n");
                   fprintf(fp,"if exist GoGet.Bat Call GoGet.Bat\r\n");
                   fprintf(fp,"if NOT exist GoGet.Bat Call GoGetLog.Bat\r\n");
                   fprintf(fp,"goto done\r\n");
                   fprintf(fp,"\r\n");
                   fprintf(fp,":notexi\r\n");
                   fprintf(fp,"Echo GoGet.Bat wasn't found.  Please place in DATA\\ with GoGet.Bat\r\n");
                   fprintf(fp,"Echo and have DATA\\WGet.EXE or better yet DATA\\DLTools\\WGet.Exe.\r\n");
                   fprintf(fp,"Pause\r\n");
                   fprintf(fp,"\r\n");
                   fprintf(fp,"goto end\r\n");
                   fprintf(fp,"\r\n");
                   fprintf(fp,":done\r\n");
                   fprintf(fp,"set AlNudInQ=\r\n");
                   fprintf(fp,"Set AlNudQPs=\r\n");
                   fprintf(fp,"Set AlNudWGOk=\r\n");
                   fprintf(fp,"\r\n");
                   fprintf(fp,":end\r\n");
                   
                   fclose(fp);           
              }//end if(writeWGet)
          }//end if(RB_InternalFiles->value())
          else if(RB_MirrorFiles->value())
          {
                //set mirrorLoc
                set_mirrorLoc();
                strcpy(downloadedFileURL,mirrorLoc);
                usehttp=true;               
          }
          else if(RB_CustomLocationFiles->value())
          {
                char copyOfInput[_MAX_PATH*4];
                strcpy(copyOfInput,InputOfCustomLocation->value());
                usehttp=(bool)strstr(InputOfCustomLocation->value(),"http://");
                if(usehttp)
                {
                     strcpy(downloadedFileURL,InputOfCustomLocation->value());
                }
                else if(strstr(InputOfCustomLocation->value(),"file://"))
                {
                     char *afterProtocol;
                     strcpy(copyOfInput,InputOfCustomLocation->value());
                     afterProtocol=&(copyOfInput[7]);//after "file://"
                     spawnlp(P_WAIT,shellName,shellName,"/c","copy",afterProtocol,wowDataLocation,NULL);                     
                }
          }
      
          if(usehttp)
          {
                //work more on getting Helper application
                char lwrCaseFName[32];
                char currDir[_MAX_PATH+2];
          
          
                strcpy(lwrCaseFName,NLBatFile[1*(int)NudityLevelSlider->value()]);
                strlwr(lwrCaseFName);
                strcat(downloadedFileURL,lwrCaseFName);

                getcwd(currDir,_MAX_PATH);
                chdir(wowDataLocation);
                spawnlp(P_WAIT,outputFilePath,outputFilePath,downloadedFileURL,NULL);
                chdir(currDir);
                usehttp=false;           
          }
                        
     }//end if using a helper

     char goInstPath[_MAX_PATH];
     char promptDelGoInst[1024+_MAX_PATH];
     strcpy(goInstPath,wowDataLocation);
     strcat(goInstPath,"GoInst.BTM");
     if(isFileExist(goInstPath))
     {
            strcpy(promptDelGoInst,"A copy of GoInst.BTM was found at:\n");
            strcat(promptDelGoInst,goInstPath);
            strcat(promptDelGoInst,"\nIt is highly recommended to back up this");
            strcat(promptDelGoInst,"\nfile outside of DATA\\ / DATA\\DLTools\\.");            
            strcat(promptDelGoInst,"\nWould you like to delete this file to\n");
            strcat(promptDelGoInst,"ensure no older version is being run?\n");
            if(fl_choice(promptDelGoInst,"Abort","Continue",NULL))            
                   unlink(goInstPath);
     }
     strcpy(goInstPath,wowDataLocation);
     strcat(goInstPath,"DLTools\\");
     strcat(goInstPath,"GoInst.BTM");
     if(isFileExist(goInstPath))
     {
            strcpy(promptDelGoInst,"A copy of GoInst.BTM was found at:\n");
            strcat(promptDelGoInst,goInstPath);
            strcat(promptDelGoInst,"\nIt is highly recommended to back up this");
            strcat(promptDelGoInst,"\nfile outside of DATA\\ / DATA\\DLTools\\.");            
            strcat(promptDelGoInst,"\nWould you like to delete this file to\n");
            strcat(promptDelGoInst,"ensure no older version is being run?\n");
            if(fl_choice(promptDelGoInst,"Abort","Continue",NULL))            
                   unlink(goInstPath);
     }     
     
     //execute helperBat
     char currDir[_MAX_PATH+2];
     getcwd(currDir,_MAX_PATH);
     chdir(wowDataLocation);

     //Remove trailing backslash.  This was found to have no effect: Seems that
              //chdir will work either way.
     char destDir[_MAX_PATH+2];
     strcpy(destDir,wowDataLocation);
     destDir[strlen(destDir)-1]='\0';
     chdir(destDir);

     char AboutToRun[_MAX_PATH+80];
     strcpy(AboutToRun,"Done with file creation, about to run program.\n");
     strcat(AboutToRun,pathToUse);
     char tmpCurrDirStr[_MAX_PATH+2];
     getcwd(tmpCurrDirStr,_MAX_PATH);
     strcat(AboutToRun,"\nis about to be run from the\n");
     strcat(AboutToRun,tmpCurrDirStr);
     strcat(AboutToRun,"\ndirectory.");
     //strcat(AboutToRun,"\n");
     //strcat(AboutToRun,destDir);          
     //strcat(AboutToRun,"\n");
     //strcat(AboutToRun,wowDataLocation);
     //fl_message("Done with file creation, about to run program.");
     //fl_message(pathToUse);


     //fl_message(AboutToRun);
     if(fl_choice(AboutToRun,"Abort","Continue",NULL))
           spawnlp(P_NOWAIT,shellName,shellName,"/c",pathToUse,NULL);
     chdir(currDir);

     return;
     
}

void init_possibleMPQOutputNames()
{
     char currNameCtr=0;
     char tempStr[_MAX_PATH];     
     if(strlen(*possibleMPQOutputNames))
          return;
          //init possibleMPQOutputNames
          strcpy(*possibleMPQOutputNames,"patch.mpq");
          strcpy(possibleMPQOutputNames[(++currNameCtr)++],"patch-x.mpq");
          for(int i=1;i<=9;i++)
          {
              strcpy(possibleMPQOutputNames[currNameCtr],"patch-");
              sprintf(tempStr,"%d",i);
              strcat(possibleMPQOutputNames[currNameCtr],tempStr);
              strcat(possibleMPQOutputNames[currNameCtr++],".mpq");
          }
          for(int i=0;i<=0;i++)
          {
              strcpy(possibleMPQOutputNames[currNameCtr],"patch-");
              sprintf(tempStr,"%d",i);
              strcat(possibleMPQOutputNames[currNameCtr],tempStr);
              strcat(possibleMPQOutputNames[currNameCtr++],".mpq");
          }
          for(char j='a';j<='z';j++)
          {
              if(j<='x')
              {
                 strcpy(possibleMPQOutputNames[currNameCtr],"patch-");
                 sprintf(tempStr,"%d",j);
                 strcat(possibleMPQOutputNames[currNameCtr],tempStr);
                 strcat(possibleMPQOutputNames[currNameCtr++],".mpq");
              }
          }     
}

void butSuggestMPQName_cb( Fl_Widget* o, void*  ) {
     //Suggests MPQ name
     //38 = 26 letters + 10 numbers + 1 blank entry at end to be used as flag     
     unsigned currNameCtr=0;
     char tempStr[_MAX_PATH];     

     init_possibleMPQOutputNames();
          currNameCtr=0;
          while(strlen(possibleMPQOutputNames[currNameCtr]))
          {
              strcpy(tempStr,wowDataLocation);
              strcat(tempStr,possibleMPQOutputNames[currNameCtr]);
              if(!isFileExist(tempStr))
              {    
                   strcpy(recOutMPQName,possibleMPQOutputNames[currNameCtr]);
                   RecMPQNameLabel->label(recOutMPQName);
                   break;
              }
              currNameCtr++;                                                  
          }
          return;
}

void butRunWow_cb( Fl_Widget* o, void*  ) {
     //runs WoW
     char WoWExeLoc[_MAX_PATH];
     strcpy(WoWExeLoc,wowLocation);
     strcat(WoWExeLoc,"WoW.exe");
     spawnlp(P_NOWAIT,WoWExeLoc,WoWExeLoc,NULL,shellName,"/c",WoWExeLoc,NULL);     
     window->redraw();
}

void butRunWoWLauncher_cb( Fl_Widget* o, void*  ) {
     //runs WoW Launcher
     char WoWExeLoc[_MAX_PATH];
     strcpy(WoWExeLoc,wowLocation);
     strcat(WoWExeLoc,"Launcher.exe");
     spawnlp(P_NOWAIT,WoWExeLoc,WoWExeLoc,NULL,shellName,"/c",WoWExeLoc,NULL);
     window->redraw();
}

void butVisitMirror_cb( Fl_Widget* o, void*  ) {
     //runs Visit Mirror
     set_mirrorLoc();
     char cmdToRun[_MAX_PATH*2];
     if(strlen(mirrorLoc))
     {
          strcpy(cmdToRun,"");
          //strcpy(cmdToRun,"start ");
          strcat(cmdToRun,mirrorLoc);
          //spawnlp(P_NOWAIT,"start.exe","start.exe",cmdToRun,NULL);
          //Above line works in Win9X where there is Start.Exe, but not Win2k
          //      where Start seems internal to command prompt
          spawnlp(P_NOWAIT,shellName,shellName,"/c","start",cmdToRun,NULL);
     }
     else fl_message("No mirror selected.  Please select a mirror under\nthe \"Use mirror site\" radio button.");
}

void butDelMPQFiles_cb( Fl_Widget* o, void*  ) {
     //Deletes MPQ files believed to be custom
     char fullFilename[_MAX_PATH];
     init_possibleMPQOutputNames();
     unsigned currNameCtr=1;//skip the patch.mpq entry, start with patch-x.mpq
     if(!fl_choice("Suggested action: ABORT\n\nIt is now recommended to NOT delete these\nfiles with this\
button, as that should\nbe unncessary.  Instead just\noverwrite/delete the\
\nfiles if/when prompted.\nHowever, there wasn't compelling reason to\n\
remove the button.  Be sure to back up\nGoInst.BTM and Continue if you wish.",NULL,"Continue","Abort"))
           return;
     while(strlen(possibleMPQOutputNames[currNameCtr]))
     {
          strcpy(fullFilename,wowDataLocation);
          strcat(fullFilename,possibleMPQOutputNames[currNameCtr]);
         if(isFileExist(fullFilename))
             unlink(fullFilename);//DELETE_IT!
         else currNameCtr++;
     }
     //better yet, instead of (or at least after) the while, use
     //       findfirst("patch-?")?  Would probably be good not to use findnext.
     //       Just get filename, findclose() so handle is closed and deleting
     //       won't cause a problem, then delete file, then repeat findfirst().     
}

void butWriteSrc_cb( Fl_Widget* o, void*  ) {
     //writes Src
     FILE *fp;
               fp = fopen("gogetexe.cpp","wb");
               if(!fp)
               {          
                     spawnlp(P_NOWAIT,shellName,shellName,"/c","Echo Cannot open GoGet.Bat for writing",NULL);
                     return;            
               }
               //gogetexeSrcData is in gogetexe07022006.h

               unsigned long fwrRet=fwrite(gogetexeSrcData,sizeof(char),gogetexeSrcDatalen,fp);
               if(fwrRet!=gogetexeSrcDatalen)
               {
                    char errMsg[4096];
                    sprintf(errMsg,"Seems there was error writing GoGetExe.cpp\nfwrite returned %ld",fwrRet);
                    fl_message(errMsg);
               }
               else
               {
                   char aftrExtractMsg[_MAX_PATH+512];
                   char currDir[_MAX_PATH];
                   getcwd(currDir,_MAX_PATH);                   
                   strcpy(aftrExtractMsg,"Some source code is now in current directory.\n");
                   strcat(aftrExtractMsg,currDir);
                   fl_message(aftrExtractMsg);
               }
               
               fclose(fp);
     //To truely output all the source, this should also run Bin2Char on the
          //embedded WGet.Exe file, and on the .cpp file, and on the embedded
          //GoGet.h file.  A modified version of Bin2Char (that had the
          //with the return(1)-after-the-output-messages removed) was used.
          //For more information on Bin2Char, see its web page at
          //http://toogam.bespin.org/toogsoft/bin2char.htm
     //This wasn't done yet for a couple of reasons: It was questioned whether
     //     it's worth the additional filesize in GoGetExe.Exe to have yet
     //     another feature, and due to a wish to not spend the development
     //     time on it yet.  However, it should be fairly easy to do by
     //     either running Bin2Char or even integrating Bin2Char's source code.
     //     And with C code of 8,039 bytes large (including comments) and an old
     //     12,059 compressed DOS executable, filesize shouldn't be too big of
     //     an issue.
}

void butDelPatBatFiles_cb( Fl_Widget* o, void*  ) {
     //Deletes files (GoGet, all Helper app batch files, Wget.  Does not delete
     //        patch-?.mpq)     
     char tempStr[_MAX_PATH];
     unsigned i=0;
     strcpy(tempStr,wowDataLocation);
     strcat(tempStr,"DLTools\\WGet.Exe");
     if(isFileExist(tempStr))
          unlink(tempStr);//DELETE IT!
     
     while(strlen(NLBatFile[i]) && strcmp(NLBatFile[i],"CustmRun.Bat"))
     {
          strcpy(tempStr,wowDataLocation);
          strcat(tempStr,NLBatFile[i]);
          if(isFileExist(tempStr))
               unlink(tempStr);//DELETE IT!
          i++;
     }
     strcpy(tempStr,wowDataLocation);
     strcat(tempStr,"GoInst.BTM");
     if(isFileExist(tempStr))
          unlink(tempStr);//DELETE IT!     
     strcpy(tempStr,wowDataLocation);
     strcat(tempStr,"DLTools\\GoInst.BTM");
     if(isFileExist(tempStr))
          unlink(tempStr);//DELETE IT!
}

void butWriteRegistryEntry_cb( Fl_Widget* o, void*  ) {
     //Writes to registry
     HKEY searchedIn=HKEY_LOCAL_MACHINE;

     unsigned long bufferSize=_MAX_PATH;          
     unsigned char buffer[bufferSize];
     strcpy((char *)buffer,wowLocation);
     
     SetRegString(searchedIn,"Software\\Blizzard Entertainment\\World of Warcraft", "InstallPath",buffer,bufferSize);
     getWoWRegValue();
     return;     
}

void butCloseProg_cb( Fl_Widget* o, void*  ) {
     exit(0);
}

bool isValidWoWDirectory(char *tested)
{
     char temp[_MAX_PATH];
     strcpy(temp,tested);
     strcat(temp,"WoW.exe");
     if(!isFileExist(temp))
          return false;
     strcpy(temp,tested);
     strcat(temp,"DATA\\texture.MPQ");
     if(!isFileExist(temp))
           return false;
     return true;          
}

void butGetManSelectedDir_cb ( Fl_Widget* o, void* ) {
     char *cur;
     char dirLookedAt[_MAX_PATH]="";
     //strcpy(dirLookedAt,"");     
     char *dirLookedAtRet=fl_dir_chooser("Select WoW directory",NULL,0);
     if(!dirLookedAtRet)
          return;
     strcat(dirLookedAt,dirLookedAtRet);
        cur=dirLookedAt;
        do
           if(*cur=='/')
              *cur='\\';
        while(*(cur++));
        strcat(dirLookedAt,"\\");

     if(isValidWoWDirectory(dirLookedAt))
     {
        strcpy(ManSelectedDir,dirLookedAt);
        ManSelectedDirOut->label(ManSelectedDir);
        groupA_RB_cb(NULL);
        RB_ManualEntry->take_focus();
     }
     //groupA->redraw();
     window->redraw();
}

char wowLocationText[_MAX_PATH+1024];

void getWoWRegValue()
{
          char regValue[_MAX_PATH];
          unsigned long bufferSize=_MAX_PATH;          
          unsigned char buffer[bufferSize];

               //HKEY TopLevelKey==HKEY_CURRENT_USER
          HKEY searchedIn=HKEY_LOCAL_MACHINE;
          if( GetRegString(searchedIn,"Software\\Blizzard Entertainment\\World of Warcraft", "InstallPath",buffer,bufferSize) )
                    strcpy(regValue, GetRegString(searchedIn,"Software\\Blizzard Entertainment\\World of Warcraft", "InstallPath",buffer,bufferSize) );
          else
              strcpy(regValue,"Searched value was NULL");

          strcpy(strWoWLocationFromReg,regValue);
          RegOut->label(strWoWLocationFromReg);
                          
          if(isValidWoWDirectory(strWoWLocationFromReg)) //if registry's value points to WoW okay
          {
                strcpy(wowLocation,strWoWLocationFromReg);
                RB_WindowsRegistryEntry->activate();
          }
          else
              RB_WindowsRegistryEntry->deactivate();


          wowDirSet();
     
}     

void groupA_RB_cb( Fl_Radio_Round_Button *b) {

          butGetManSelectedDir->deactivate();
     
     if(RB_WindowsRegistryEntry->value())
     {
          getWoWRegValue();
     }
     else if(RB_ManualEntry->value())
     {    strcpy(wowLocation,ManSelectedDirOut->label());
          butGetManSelectedDir->activate();
          wowDirSet();
     }
     else if(RB_FindEntry->value())
     {
          strcpy(wowLocation,"No such entry yet");
          wowDirSet();
     }
     else
     {
         getWoWRegValue();
         if(!isValidWoWDirectory(strWoWLocationFromReg))
               RB_WindowsRegistryEntry->deactivate();
          if(RB_WindowsRegistryEntry->active())
                    RB_WindowsRegistryEntry->value( RB_WindowsRegistryEntry->active() );
          else RB_ManualEntry->value( RB_ManualEntry->active() );
          
          groupA_RB_cb(NULL);
     }
     
     sprintf(wowLocationText,"Specify WoW Location: Currently %s",wowLocation);
     groupATitle->label(wowLocationText);
}

void RB_WindowsRegistryEntry_cb ( Fl_Widget* o, void* ) {
     Fl_Radio_Round_Button *b=(Fl_Radio_Round_Button *)o;
     groupA_RB_cb(b);
}

void RB_ManualEntry_cb ( Fl_Widget* o, void* ) {
     Fl_Radio_Round_Button *b=(Fl_Radio_Round_Button *)o;
     groupA_RB_cb(b);
}

void RB_FindEntry_cb ( Fl_Widget* o, void* ) {
     Fl_Radio_Round_Button *b=(Fl_Radio_Round_Button *)o;
     groupA_RB_cb(b);     
}

void groupC_RB_cb( Fl_Radio_Round_Button *b) {

     RB_MirrorFilesLocationWcSkinsCom->deactivate();
     RB_MirrorFilesLocationGigabitAdult->deactivate();
     RB_MirrorFilesLocationToogCom->deactivate();
     RB_MirrorFilesLocationBespin->deactivate();
     RB_MirrorFilesLocationLocalNet->deactivate();     

     InputOfCustomLocation->deactivate();
     butPickLclFileURL->deactivate();
     
     if(RB_InternalFiles->value())
          ;
     else if(RB_MirrorFiles->value())
     {    
          RB_MirrorFilesLocationWcSkinsCom->activate();
          RB_MirrorFilesLocationGigabitAdult->activate();
          RB_MirrorFilesLocationToogCom->activate();
          RB_MirrorFilesLocationBespin->activate();
          RB_MirrorFilesLocationLocalNet->activate();
          set_mirrorLoc();
          if(!strlen(mirrorLoc))
               RB_MirrorFilesLocationWcSkinsCom->value(1);
     }
     else if(RB_CustomLocationFiles->value())
     {
          InputOfCustomLocation->activate();
          butPickLclFileURL->activate();          
     }
     else {
          RB_InternalFiles->value(1);
          groupC_RB_cb(NULL);     
     }
     
     //sprintf(wowLocationText,"Specify WoW Location: Currently %s",wowLocation);
     //groupATitle->label(wowLocationText);
}

void RB_InternalFiles_cb ( Fl_Widget* o, void* ) {
     Fl_Radio_Round_Button *b=(Fl_Radio_Round_Button *)o;
     groupC_RB_cb(b);     
}

void RB_MirrorFiles_cb ( Fl_Widget* o, void* ) {
     Fl_Radio_Round_Button *b=(Fl_Radio_Round_Button *)o;
     groupC_RB_cb(b);     
}

void RB_CustomLocationFiles_cb ( Fl_Widget* o, void* ) {
     Fl_Radio_Round_Button *b=(Fl_Radio_Round_Button *)o;
     groupC_RB_cb(b);     
}

void butPickLclFileURL_cb ( Fl_Widget* o, void* ) {

     //char dirLookedAtRet[_MAX_PATH+15];
     char *dirLookedAtRet;
     dirLookedAtRet=fl_dir_chooser("Select local directory",NULL,0);
     if(dirLookedAtRet)
     {
         char tmpStr[_MAX_PATH+15];
         strcpy(tmpStr,"file://");
         strcat(tmpStr,dirLookedAtRet);
         InputOfCustomLocation->value(tmpStr);
     }
     window->redraw();
}     


char NudityLevelLabelStr[_MAX_PATH];

void NudityLevelSlider_cb ( Fl_Widget* o, void* ) {
     Fl_Slider* s=(Fl_Slider *)o;     
     char NLBatFileDesc[][32]={"GoGet","MPQMake","EvenLess","Tab(ard)Top(s)OK","MakeTopl(ess)","FullNude","Cust(u)mRun"};
     char NLDesc[][64]={
          "Lots of prompts",//"No Helper App",
          "Nothing Extracted",
          "Skins Modified",
          "Clothes Modified",
          "Tabards Modified",
          "Models Modified",
          "Custom Modification"
     };
     sprintf(NudityLevelLabelStr,"Level %0.0f:\n %s\n%s",s->value(),NLBatFileDesc[(int)s->value()],NLDesc[(int)s->value()]);
     //sprintf(NudityLevelLabelStr,"Changed %d",(int)s->value());
     s->label(NudityLevelLabelStr);
     char x;
     x='a';
     
}

void wowDirSet() {
 //    
       if(isValidWoWDirectory(wowLocation))
       {
           butGo->activate();
           butRunWoW->activate();
           butRunWoWLauncher->activate();
           butWriteRegistryEntry->activate();
           butDelPatBatFiles->activate();
           butSuggestMPQName->activate();
           butDelMPQFiles->activate();
       }
       else
       {
           butGo->deactivate();
           butRunWoW->deactivate();
           butRunWoWLauncher->deactivate();
           butWriteRegistryEntry->deactivate();
           butDelPatBatFiles->deactivate();
           butSuggestMPQName->deactivate();
           butDelMPQFiles->deactivate();
       }
       //Unaffected buttons: but, butVisitMirror, butWriteSrc, butCloseProg
       strcpy(wowDataLocation,wowLocation);
       strcat(wowDataLocation,"DATA\\"); 
}     

LPSTR GetRegString(HKEY TopLevelKey, LPSTR KeyName, LPSTR ValueName, unsigned char *buffer, unsigned long bufferSize)

{

//http://www.borngeek.com/coding/general/registry_advanced.html
HKEY hKey;
RegOpenKeyEx(TopLevelKey, TEXT(KeyName), 0, KEY_QUERY_VALUE, &hKey);

//unsigned char buffer[_MAX_PATH];
unsigned long datatype;
unsigned long bufferlength = bufferSize;

RegQueryValueEx(hKey, ValueName, NULL, &datatype, buffer, &bufferlength);

RegCloseKey(hKey);

if(!datatype)
     return NULL;
return (LPSTR)buffer;                                                                                     
}

bool SetRegString(HKEY TopLevelKey, LPSTR KeyName, LPSTR ValueName, unsigned char *buffer, unsigned long bufferSize)

{

//http://www.borngeek.com/coding/general/registry_advanced.html
HKEY hKey;
RegOpenKeyEx(TopLevelKey, TEXT(KeyName), 0, KEY_WRITE, &hKey);

//unsigned char buffer[_MAX_PATH];
DWORD datatype;
unsigned long bufferlength = bufferSize;
datatype=REG_SZ;//http://msdn.microsoft.com/library/default.asp?url=/library/en-us/sysinfo/base/registry_value_types.asp

//RegQueryValueEx(hKey, ValueName, NULL, &datatype, buffer, &bufferlength);

//RegSetKeyValue(hKey, lpSubKey, ValueName, datatype, buffer, bufferSize);
RegSetValueEx(hKey, ValueName, 0L, datatype, buffer, bufferlength);

RegCloseKey(hKey);

return (LPSTR)buffer;                                                                                     
}


int
main (int argc, char *argv[])
{
     int retval;
     ManSelectedDir=new char[_MAX_PATH];
     
     
     if(getenv("COMSPEC"))
     {
         shellName=new char[strlen(getenv("COMSPEC"))+sizeof('\0')];
         strcpy(shellName,getenv("COMSPEC"));
     }
     else 
     {    shellName=new char[12];
          //if Win9x
          strcpy(shellName,"command.com");
          //else strcpy(shellName,"CMD");
     }
     strcpy(wowLocation,"Not yet specified");
     strcpy(wowDataLocation,wowLocation);
     
    Fl_Text_Display *Fl_TextBoxForDate;
    Fl_Text_Buffer *Fl_TextBufferForDate;
    
    
    
    char *dateInfo;
    char discInfo[4096];
    Fl_Box *BoxForProgTitle;
    Fl_Box *BoxForDate, *BoxForDisc;
    const int INDENT_AMT=30;
    const int BORDER_SPACE_AMT=10;
          
      Fl_Box *groupABorderBox;
      Fl_Box *groupBBorderBox;
      Fl_Box *groupBTitle;

    

    char strProgTitle[]="GoGetExe (helps run WoW's Patchin' Batch)";
    strcpy(strWoWLocationFromReg,"No Registry Output Yet");

    window = new Fl_Window (550, 480, strProgTitle);
    
    int x=50;
    x=145;
    dateInfo=new char[x];
    strcpy(dateInfo,"Release Date: July 4, 2006\n");
    //disclaimer:
    strcpy(discInfo,"There aren't restrictions on using, modifying, or distributing this file.  Use at own risk!\n");
    //strcat(discInfo,"file. Author accepts no responsibility for (mis)use of this product.");
   
    window->begin();
      BoxForProgTitle=new Fl_Box(window->w()/2*0+5,5,window->w()-30,35*1,strProgTitle);
      
    BoxForProgTitle->box (FL_PLASTIC_UP_BOX);
    BoxForProgTitle->labelsize (24);
    BoxForProgTitle->labelfont (FL_BOLD+FL_ITALIC);
    BoxForProgTitle->labeltype (FL_SHADOW_LABEL);
      
      Fl_TextBufferForDate=new Fl_Text_Buffer(strlen(dateInfo));
      Fl_TextBufferForDate->text(dateInfo);

      int TXT_HEIGHT_USED=18;
      
      BoxForDate=new Fl_Box(BoxForProgTitle->x()+INDENT_AMT,BoxForProgTitle->y()+BoxForProgTitle->h(),150,TXT_HEIGHT_USED,dateInfo);
      //BoxForDate->position(window->x()/2,BoxForDate->y());

      //BoxForDisc=new Fl_Box(BoxForDate->x()+INDENT_AMT,BoxForDate->y()+BoxForDate->h(),150,50,discInfo);
      BoxForDisc=new Fl_Box(BoxForProgTitle->x()+(window->x()/2*2)+200,BoxForProgTitle->y()+BoxForProgTitle->h()+BoxForDate->h()-0*BORDER_SPACE_AMT,150,TXT_HEIGHT_USED,discInfo);
      //BoxForDisc=new Fl_Box(window->w()/2*1+0*(BoxForDate->x()-INDENT_AMT),BoxForDate->y()+BoxForDate->h()-45,150,50,discInfo);
      //BoxForDisc->position(window->w()/2,BoxForDisc->y()-15);

      
      //fl_frame *groupAFrame;
      
      groupA = new Fl_Group( BoxForProgTitle->x()+BORDER_SPACE_AMT, BoxForDisc->y()+BoxForDisc->h(), 0*200+(window->w()-2*BORDER_SPACE_AMT), 400 );
      groupA->begin();

    groupABorderBox=new Fl_Box(groupA->x()+0,groupA->y()+0,groupA->w(),groupA->h(),"");
    groupABorderBox->box (FL_UP_BOX);
    groupABorderBox->labelsize (24);
    groupABorderBox->labelfont (FL_BOLD+FL_ITALIC);
    groupABorderBox->labeltype (FL_SHADOW_LABEL);

      
      //groupATitle=new Fl_Box(groupA->x()+0,groupA->y()+0,150,25,"Specify WoW Location");
      groupATitle=new Fl_Box(groupA->x()+0,groupA->y()+0,0*150+groupA->w()-2*BORDER_SPACE_AMT,TXT_HEIGHT_USED,"Specify WoW Location");

      
      
          /*
          groupATitle->box (FL_UP_BOX);
          groupATitle->labelsize (24);
          groupATitle->labelfont (FL_BOLD+FL_ITALIC);
          groupATitle->labeltype (FL_SHADOW_LABEL);
          */
      
          RB_WindowsRegistryEntry=new Fl_Radio_Round_Button(groupATitle->x()+INDENT_AMT,groupATitle->y()+groupATitle->h(),150,TXT_HEIGHT_USED,"Use Registry Value");
             RegOut=new Fl_Box(RB_WindowsRegistryEntry->x()+INDENT_AMT,(RB_WindowsRegistryEntry->y())+(RB_WindowsRegistryEntry->h())+0,150,TXT_HEIGHT_USED,strWoWLocationFromReg);
          RB_ManualEntry=new Fl_Radio_Round_Button(RB_WindowsRegistryEntry->x(),RegOut->y()+RegOut->h(),150,TXT_HEIGHT_USED,"Use Manual Entry");
             butGetManSelectedDir=new Fl_Button( RB_ManualEntry->x(), RB_ManualEntry->y()+RB_ManualEntry->h(), 67, 30, "Show Dir\nChooser" );
             butGetManSelectedDir->callback( butGetManSelectedDir_cb );
             
             ManSelectedDirOut=new Fl_Box(RB_ManualEntry->x()*0+butGetManSelectedDir->x()+butGetManSelectedDir->w()+INDENT_AMT,RB_ManualEntry->y()+(RB_ManualEntry->h())+0,150,TXT_HEIGHT_USED,"No Valid Directory Specified Yet");
             //ManSelectedDirOut->align(FL_ALIGN_RIGHT);
             
          //RB_FindEntry=new Fl_Radio_Round_Button(RB_WindowsRegistryEntry->x(),RB_FileChooser->y()+RB_FileChooser->h(),150,25,"Use Found Entry");
          RB_FindEntry=new Fl_Radio_Round_Button(RB_WindowsRegistryEntry->x(),butGetManSelectedDir->y()+butGetManSelectedDir->h()+0*75,150,TXT_HEIGHT_USED,"Use Found Entry");

      RB_WindowsRegistryEntry->callback(RB_WindowsRegistryEntry_cb);
      RB_ManualEntry->callback(RB_ManualEntry_cb);
      RB_FindEntry->callback(RB_FindEntry_cb);



      //groupABorderBox=new Fl_Box(groupA->x()+0,groupA->y()+0,groupA->w(),groupA->h(),"");

      Fl_Widget *groupAfurthestRightItem=(Fl_Widget *)RegOut;
      Fl_Widget *groupALowestChildItem=(Fl_Widget *)RB_FindEntry;
          
      groupA->end();
      //Resizing the group seems disasterous, affecting placement of children.  So we'll resize border box.
      //groupABorderBox->size(groupAfurthestRightItem->x()+groupAfurthestRightItem->w()-groupA->x(),(groupALowestChildItem->y()-groupA->y()+groupALowestChildItem->h())*1);
      groupABorderBox->size(window->w()-2*BORDER_SPACE_AMT,(groupALowestChildItem->y()-groupA->y()+groupALowestChildItem->h())*1);
             //RegOut->size(groupABorderBox->w()-(RegOut->x()),RegOut->h());
             
             
      groupA->redraw();      
   
      //groupAFrame=new Fl_Frame("GroupA",groupA->x(),groupA->y(),groupA->w(),groupA->h());

      groupB = new Fl_Group( groupA->x(), groupABorderBox->y()+groupABorderBox->h()+BORDER_SPACE_AMT, 0*(window->w()/1-3*BORDER_SPACE_AMT)+300, 400 );
      groupB->begin();

    groupBBorderBox=new Fl_Box(groupB->x()+0,groupB->y()+0,groupB->w(),groupB->h(),"");      
    groupBBorderBox->box (FL_UP_BOX);
    groupBBorderBox->labelsize (24);
    groupBBorderBox->labelfont (FL_BOLD+FL_ITALIC);
    groupBBorderBox->labeltype (FL_SHADOW_LABEL);

      groupBTitle=new Fl_Box(groupB->x(),groupB->y()+0,150,TXT_HEIGHT_USED,"Specify Nudity Level");

      NudityLevelSlider=new Fl_Hor_Nice_Slider(groupB->x()+INDENT_AMT,groupBTitle->y()+groupBTitle->h(),1*(groupB->w()-2*INDENT_AMT)+0,TXT_HEIGHT_USED,"Nudity Level");
         //NudityLevelSlider->type(FSlider::FL_HOR_NICE_SLIDER)
      NudityLevelSlider->callback( NudityLevelSlider_cb );
      NudityLevelSlider->range( 0.0, 6.0);
      NudityLevelSlider->step(1.0);
      NudityLevelSlider->value(3.0);
      NudityLevelSlider_cb(NudityLevelSlider, (void *)NULL);
      
      char winVerText[4096];
      strcpy(winVerText,"(Operating System: Undetected)");

      OSVERSIONINFO osversioninfo;

      osversioninfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
      if(GetVersionEx(&osversioninfo))
      {
          strcpy(winVerText,"");
          //sprintf(winVerText,"%ld",osversioninfo.dwPlatformId);
          //if(atoi(osversioninfo.dwPlatformId)==1)
          if(osversioninfo.dwPlatformId==1)
               sprintf(winVerText,"Win9x (Win95/98/Me) detected");
          //else if(atoi(osversioninfo.dwPlatformId)>1)
          else if(osversioninfo.dwPlatformId>1)
               sprintf(winVerText,"Not using Win9x: Another OS detected");
      }

      groupBTestText=new Fl_Box(groupB->x()+INDENT_AMT*2+0*(groupB->w()/2),NudityLevelSlider->y()+NudityLevelSlider->h()+TXT_HEIGHT_USED*3,150,TXT_HEIGHT_USED,winVerText);

      Fl_Widget *groupBfurthestRightItem=(Fl_Widget *)NudityLevelSlider;
      Fl_Widget *groupBLowestChildItem=(Fl_Widget *)groupBTestText;

       groupB->end();
      groupBBorderBox->size(groupBfurthestRightItem->x()+groupBfurthestRightItem->w()-groupB->x()+2*BORDER_SPACE_AMT,(groupBLowestChildItem->y()-groupB->y()+groupBLowestChildItem->h())*1);
      groupB->redraw();      



      groupC = new Fl_Group( groupBBorderBox->x()+groupBBorderBox->w()+BORDER_SPACE_AMT, groupABorderBox->y()+groupABorderBox->h()+BORDER_SPACE_AMT, 200, 400 );
      groupC->begin();

    Fl_Box *groupCBorderBox;
    groupCBorderBox=new Fl_Box(groupC->x(),groupC->y()+0,groupC->w(),groupC->h(),"");
    
    groupCBorderBox->box (FL_UP_BOX);
    groupCBorderBox->labelsize (24);
    groupCBorderBox->labelfont (FL_BOLD+FL_ITALIC);
    groupCBorderBox->labeltype (FL_SHADOW_LABEL);

    Fl_Box *groupCTitle;
    
    groupCTitle=new Fl_Box(groupC->x()+0*(groupC->w()/2)+BORDER_SPACE_AMT,groupC->y(),groupC->w()-2*BORDER_SPACE_AMT,TXT_HEIGHT_USED,"Location to get GoGet.Bat from");

      RB_InternalFiles=new Fl_Radio_Round_Button(groupC->x()+INDENT_AMT,groupCTitle->y()+groupCTitle->h(),150,TXT_HEIGHT_USED,"Use Internal Files");
      RB_MirrorFiles=new Fl_Radio_Round_Button(RB_InternalFiles->x(),RB_InternalFiles->y()+RB_InternalFiles->h(),150,TXT_HEIGHT_USED,"Use mirror site");
          groupCSubA=new Fl_Group( groupB->x()+groupB->w()+INDENT_AMT, groupABorderBox->y()+groupABorderBox->h()+10, 200, 400 );
          groupCSubA->begin();
               RB_MirrorFilesLocationWcSkinsCom=new Fl_Radio_Round_Button(RB_MirrorFiles->x()+INDENT_AMT,RB_MirrorFiles->y()+RB_MirrorFiles->h(),150,15,"WarCraftSkins.Com");
               RB_MirrorFilesLocationGigabitAdult=new Fl_Radio_Round_Button(RB_MirrorFiles->x()+INDENT_AMT,RB_MirrorFilesLocationWcSkinsCom->y()+RB_MirrorFilesLocationWcSkinsCom->h(),150,RB_MirrorFilesLocationWcSkinsCom->h(),"Gigabit Adult");
               RB_MirrorFilesLocationToogCom=new Fl_Radio_Round_Button(RB_MirrorFiles->x()+INDENT_AMT,RB_MirrorFilesLocationGigabitAdult->y()+RB_MirrorFilesLocationGigabitAdult->h(),150,RB_MirrorFilesLocationGigabitAdult->h(),"Dev's Domain");
               RB_MirrorFilesLocationBespin=new Fl_Radio_Round_Button(RB_MirrorFiles->x()+INDENT_AMT,RB_MirrorFilesLocationToogCom->y()+RB_MirrorFilesLocationToogCom->h(),150,RB_MirrorFilesLocationToogCom->h(),"Bespin Mirror");
               RB_MirrorFilesLocationLocalNet=new Fl_Radio_Round_Button(RB_MirrorFiles->x()+INDENT_AMT,RB_MirrorFilesLocationBespin->y()+RB_MirrorFilesLocationBespin->h(),150,RB_MirrorFilesLocationBespin->h(),"Local Network");
          groupCSubA->end();               
      RB_CustomLocationFiles=new Fl_Radio_Round_Button(RB_MirrorFiles->x(),RB_MirrorFilesLocationLocalNet->y()+RB_MirrorFilesLocationLocalNet->h(),150,TXT_HEIGHT_USED,"Use custom location");
          InputOfCustomLocation=new Fl_Input(RB_CustomLocationFiles->x()+INDENT_AMT,RB_CustomLocationFiles->y()+RB_CustomLocationFiles->h(),150,TXT_HEIGHT_USED,"");
          InputOfCustomLocation->value("Can be http:// or file://");
          butPickLclFileURL=new Fl_Button( InputOfCustomLocation->x(), InputOfCustomLocation->y()+InputOfCustomLocation->h(), 95, TXT_HEIGHT_USED, "Pick file:// URL" );
          butPickLclFileURL->callback(butPickLclFileURL_cb);

      RB_InternalFiles->callback(RB_InternalFiles_cb);
      RB_MirrorFiles->callback(RB_MirrorFiles_cb);
      RB_CustomLocationFiles->callback(RB_CustomLocationFiles_cb);

      Fl_Widget *groupCfurthestRightItem=(Fl_Widget *)RB_MirrorFilesLocationWcSkinsCom;
      Fl_Widget *groupCLowestChildItem=(Fl_Widget *)butPickLclFileURL;

       groupC->end();
      groupCBorderBox->size(groupCfurthestRightItem->x()+groupCfurthestRightItem->w()-groupC->x()+BORDER_SPACE_AMT,(groupCLowestChildItem->y()-groupC->y()+groupCLowestChildItem->h())*1+BORDER_SPACE_AMT);      
      groupC->redraw();      

      groupD = new Fl_Group( groupBBorderBox->x(), groupBBorderBox->y()+groupBBorderBox->h()+BORDER_SPACE_AMT, groupBBorderBox->w(), 400 );
      groupD->begin();

    Fl_Box *groupDBorderBox;
    groupDBorderBox=new Fl_Box(groupD->x(),groupD->y()+0,groupD->w(),groupD->h(),"");
    
    groupDBorderBox->box (FL_UP_BOX);
    groupDBorderBox->labelsize (24);
    groupDBorderBox->labelfont (FL_BOLD+FL_ITALIC);
    groupDBorderBox->labeltype (FL_SHADOW_LABEL);

    Fl_Box *groupDTitle;
    
    groupDTitle=new Fl_Box(groupD->x()+0*(groupD->w()/2)+BORDER_SPACE_AMT,groupD->y(),groupD->w()-2*BORDER_SPACE_AMT,TXT_HEIGHT_USED,"Suggested MPQ name");


      RecMPQNameLabel=new Fl_Box(groupD->x()+BORDER_SPACE_AMT,groupDTitle->y()+groupDTitle->h()+0*BORDER_SPACE_AMT,groupD->w()-2*BORDER_SPACE_AMT,TXT_HEIGHT_USED,"None yet.  Press button for one.");

      Fl_Widget *groupDfurthestRightItem=(Fl_Widget *)RecMPQNameLabel;
      Fl_Widget *groupDLowestChildItem=(Fl_Widget *)RecMPQNameLabel;

      groupD->end();
      groupDBorderBox->size(groupDfurthestRightItem->x()+groupDfurthestRightItem->w()-groupD->x(),(groupDLowestChildItem->y()-groupD->y()+groupDLowestChildItem->h())*1);      
      groupD->redraw();      



    butGo=new Fl_Button(BORDER_SPACE_AMT,window->h()-1*BORDER_SPACE_AMT-2*32,85,32,"Run Patch");
    butGo->callback( butGo_cb );
    butGo->position(BORDER_SPACE_AMT*3+butGo->w()*2,window->h()-2*BORDER_SPACE_AMT-3*butGo->h());

    butShowDir=new Fl_Button( 10, 300, butGo->w(), butGo->h(), "Show DIR of\nPatc*.MPQ" );
    butShowDir->callback( butShowDir_cb );
    butShowDir->position(butShowDir->x(),window->h()-2*BORDER_SPACE_AMT-3*butShowDir->h());

    butShowScrnShDir=new Fl_Button(butShowDir->x()+butShowDir->w()+BORDER_SPACE_AMT,butShowDir->y(),butGo->w(),butGo->h(), "Show Scrn-\nshot dir" );
    butShowScrnShDir->callback( butShowScrnShDir_cb );

//    butReReadReg=new Fl_Button (butShowScrnShDir->x()+butShowScrnShDir->w()+BORDER_SPACE_AMT,butShowScrnShDir->y(),butGo->w(),butGo->h(),"Accomplish\nNothing");
//    butReReadReg->callback( butReReadReg_cb );
    butReReadReg=new Fl_Button (butShowScrnShDir->x()+butShowScrnShDir->w()+BORDER_SPACE_AMT,butShowScrnShDir->y(),butGo->w(),butGo->h(),"Re-read\nRegistry");
    butReReadReg->callback( butReReadReg_cb );
    butReReadReg->position(BORDER_SPACE_AMT,window->h()-1*BORDER_SPACE_AMT-2*butGo->h());

    butSuggestMPQName=new Fl_Button (butReReadReg->x()+butReReadReg->w()+BORDER_SPACE_AMT,butReReadReg->y(),butReReadReg->w(),butReReadReg->h(),"Suggest\nMPQ Name");
    butSuggestMPQName->callback( butSuggestMPQName_cb );

    butRunWoW=new Fl_Button (butSuggestMPQName->x()+butSuggestMPQName->w()+BORDER_SPACE_AMT,butSuggestMPQName->y(),butGo->w(),butGo->h(),"Run WoW");
    butRunWoW->callback( butRunWow_cb );    

    butRunWoWLauncher=new Fl_Button (butRunWoW->x()+butRunWoW->w()+BORDER_SPACE_AMT,butRunWoW->y(),butGo->w(),butGo->h(),"Run WoW\nLauncher");
    butRunWoWLauncher->callback( butRunWoWLauncher_cb );    

    //butVisitMirror=new Fl_Button(butRunWoWLauncher->x()+butRunWoWLauncher->w()+BORDER_SPACE_AMT,butRunWoW->y(),butGo->w(),butGo->h(),"Visit\nMirror URL");
    //butVisitMirror=new Fl_Button(BORDER_SPACE_AMT,window->h()-BORDER_SPACE_AMT-30,butGo->w(),butGo->h(),"Visit\nMirror URL");
    butVisitMirror=new Fl_Button(butRunWoWLauncher->x()+butRunWoWLauncher->w()+BORDER_SPACE_AMT,butRunWoWLauncher->y(),butGo->w(),butGo->h(),"Visit\nMirror URL");
    butVisitMirror->callback( butVisitMirror_cb );    
    //butVisitMirror->position(BORDER_SPACE_AMT,window->h()-BORDER_SPACE_AMT-30);

    butWriteSrc=new Fl_Button(butVisitMirror->x()+butVisitMirror->w()+BORDER_SPACE_AMT,butVisitMirror->y(),butGo->w(),butGo->h(),"Write Src");
    butWriteSrc->callback( butWriteSrc_cb );
    butWriteSrc->position(BORDER_SPACE_AMT,window->h()-0*BORDER_SPACE_AMT-butWriteSrc->h());

    butDelMPQFiles=new Fl_Button(butWriteSrc->x()+butWriteSrc->w()+BORDER_SPACE_AMT,butWriteSrc->y(),butGo->w(),butGo->h(),"Erase some\nPatch-?.mpq");
    butDelMPQFiles->callback( butDelMPQFiles_cb );

    butDelPatBatFiles=new Fl_Button(butDelMPQFiles->x()+butDelMPQFiles->w()+BORDER_SPACE_AMT,butWriteSrc->y(),butGo->w(),butGo->h(),"Erase Pat'n\nBat's Files");
    butDelPatBatFiles->callback( butDelPatBatFiles_cb );

    butWriteRegistryEntry=new Fl_Button(butDelPatBatFiles->x()+butDelPatBatFiles->w()+BORDER_SPACE_AMT,butDelPatBatFiles->y(),butGo->w(),butGo->h(),"Write Reg");
    butWriteRegistryEntry->callback( butWriteRegistryEntry_cb );    

    butCloseProg=new Fl_Button(butWriteRegistryEntry->x()+butWriteRegistryEntry->w()+BORDER_SPACE_AMT,butWriteRegistryEntry->y(),butGo->w(),butGo->h(),"Quit");
    butCloseProg->callback( butCloseProg_cb );    


//cancel, registry, src
   
   
   
   
    window->end ();

    //deactivate things not yet programmed
         RB_FindEntry->deactivate();
         //RB_MirrorFiles->deactivate();
         //RB_CustomLocationFiles->deactivate();
         //butVisitMirror->deactivate();

    //set defaults
        groupA_RB_cb(NULL);
        groupC_RB_cb(NULL);        

        window->resizable(window);
    window->show (argc, argv);

    retval=Fl::run();




    return retval;

}


